---
  kind: "Template"
  apiVersion: "v1"
  metadata:
    name: "crawler-job-entrypoint-file"
    creationTimestamp: null
  labels:
    template: "crawler-job-entrypoint-file"
  objects:
    -
      apiVersion: batch/v1
      kind: Job
      metadata:
        name: crawler-job-entrypoint-file
      spec:
        template:
          spec:
            containers:
            #### Redis ####
            - name: redis
              env:
                - name: TZ
                  value: Europe/Zurich
              image: redis
              imagePullPolicy: Always
              ports:
                - containerPort: 6379
                  name: tcp
                  protocol: TCP
              readinessProbe:
                exec:
                  command:
                    - sh
                    - '-c'
                    - redis-cli -h $(hostname) ping
                failureThreshold: 3
                initialDelaySeconds: 15
                periodSeconds: 10
                successThreshold: 1
                timeoutSeconds: 5
              resources: {}
              terminationMessagePath: /dev/termination-log
              terminationMessagePolicy: File
              volumeMounts:
                - mountPath: /data
                  name: data
            #### Job ####
            - name: crawler-job-entrypoint-file
              image: '${IMAGE}'
              command:
                - /bin/bash
                - -c
                - python cern_web_crawler/manager.py && redis-cli shutdown NOSAVE
              lifecycle:
                preStop:
                  exec:
                    command: ["/bin/sh","-c",'redis-cli shutdown NOSAVE']
              env:
              - name: WCRAWLER_PUBLIC_fileS_REST_CREDENTIALS
                valueFrom:
                  secretKeyRef:
                    key: credentials
                    name: webservices
              - name: WCRAWLER_PUBLIC_CRAWLER_SENTRY_DSN
                valueFrom:
                  secretKeyRef:
                    key: dsn
                    name: sentry
              - name: WCRAWLER_PUBLIC_SPIDER_API_TOKEN
                valueFrom:
                  secretKeyRef:
                    key: token
                    name: searchapi
              envFrom:
                - configMapRef:
                    name: web-crawler-config-entrypoint-file
              resources:
                limits:
                  cpu: "2"
                  memory: 4Gi
                requests:
                  cpu: "1"
                  memory: 2Gi
              terminationMessagePath: /dev/termination-log
              terminationMessagePolicy: File
              volumeMounts:
              - mountPath: /tmp/run
                name: tmp-dir
              - mountPath: /scrapy/entrypoint-sites
                name: public-sites-volume
                subPath: data

            restartPolicy: OnFailure
            volumes:
              - emptyDir: {}
                name: tmp-dir
              - emptyDir: {}
                name: data
              - configMap:
                  defaultMode: 420
                  name: public-sites
                name: public-sites-volume
  parameters:
    - name: IMAGE
      value: 'gitlab-registry.cern.ch/webservices/cern-search/web-crawler:latest'